;
; Integer square root with CORDIC algorithm
; 
; OH2NLT, Juha Niinikoski 12.06.2006
;
; Hitec assembler generates carbage for hardware do loop !
; Therefore software loop counter used.
;
; Loop counter removed. Loop end tested directly from probe mask
;
; AM demodulator code added 13.06.2006
;

; unsigned int csqr(unsigned long);
	global	_csqr
; unsigned int amdemod(void);	
	global	_amdemod

	psect	text,class=CODE,delta=2,reloc=4

#include <as30f6014.h>	; Processor EQUs, Remember to Compile with -P option.

NUMBITS equ 32						; how many bits we calculate
; w1:w0 = x
; w2 = probe
; w3 = y
; w4 = i (loop counter)
; W7:w6 = y*y



_csqr:

	mov #(1<<((NUMBITS/2)-1)),w2	; set initial probe mask
	mov #0,w3						; y (root) = 0
;	mov #(NUMBITS/2),w4				; load do loop counter

; comment hardware do out if zero mask is tested for end condition
	do #((NUMBITS/2)-1),no_result_addjust	; set up hardware loop
root_loop:
	add w3,w2,w3					; y += probe

	mul.uu w3,w3,w6					; w6:w7 = y*y

	cp w7,w1						; compare high word y-x
	bra nz, hi_rules				; high word rules
	cp w6,w0						; compare low word y-x
hi_rules:
	bra leu, no_result_addjust		; no y back addjust

	sub w3,w2,w3					; y -= probe

no_result_addjust:
	lsr w2,#1,W2					; lsr probe

; comment zero mask test out if hardware do loop is used
;	bra nz,root_loop

	mov w3,w0						; return with y (square root of x)
	return

;
; AM demodulator
; am = sqr(i^2 + q^2)
;


_amdemod:

	mov RXBUF0,w2					; get codec inputs 
	mov	RXBUF1,w3

	mul.ss w2,w2,w4					; square I
	mul.ss w3,w3,w6					; square Q

	add.w w4,w6,w0					; add I^2 + Q^2
	addc.w w5,w7,w1

//	rrc	w1,w1						; divide result by 2, fit to 32 bits
//	rrc w0,w0

	bra	_csqr						; calculate square root from w1:w0
